/**
 * Copyright (C) 2017 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var RE = {};

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0};

RE.editor = document.getElementById('editor');

document.addEventListener("selectionchange", function() { RE.backuprange(); });

// Initializations
RE.callback = function() {
    window.location.href = "re-callback://" + encodeURI(RE.getHtml());
};

RE.setHtml = function(contents) {
   RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));
       //RE.editor.innerHTML=contents;
};

RE.setUnEdit=function(){
     RE.editor.contenteditable="false";
};
RE.getHtml = function() {
    return RE.editor.innerHTML;
};

RE.getText = function() {
    return RE.editor.innerText;
};

RE.setBaseTextColor = function(color) {
    RE.editor.style.color  = color;
};

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
};

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
};

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
};

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
};

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
};

RE.setHeight = function(size) {
    RE.editor.style.height = size;
};

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
};

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
};

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
};

RE.setInputEnabled = function(inputEnabled) {
    RE.editor.contentEditable = String(inputEnabled);
};

RE.undo = function() {
    document.execCommand('undo', false, null);
};

RE.redo = function() {
    document.execCommand('redo', false, null);
};

RE.setBold = function() {
    document.execCommand('bold', false, null);
};

RE.setItalic = function() {
    document.execCommand('italic', false, null);
};

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
};

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
};

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
};

RE.setUnderline = function() {
    document.execCommand('underline', false, null);
};

RE.setBullets = function() {
    document.execCommand('insertUnorderedList', false, null);
};

RE.setNumbers = function() {
    document.execCommand('insertOrderedList', false, null);
};

RE.setTextColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
};

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
};

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
};

RE.setHeading = function(heading) {
    document.execCommand('formatBlock', false, '<h'+heading+'>');
};

RE.setIndent = function() {
    document.execCommand('indent', false, null);
};

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
};

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
};

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
};

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
};

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
};
//onclick="RE.removeDiv(this)"
RE.insertImage = function(url, alt) {
    var html='<div>'
     html+= '<img width="100%"  id="1"  src="' + url + '?x-oss-process=image/auto-orient,1"  dataLabel="' + alt + '" />';
//    html+='<hr align=center width=50% color=#987cb9 size=1 style="margin:50px auto"/>'
    html+='</div>'
    html+='<div><br/></div>'
    RE.insertHTML(html);
  //  RE.scrollToBottom();
};
RE.removeDiv=function(obj){
    console.log($(obj).html());
    document.execCommand('Delete', false, $(obj).html());
};



//style="object-fit: cover"
RE.insertImageGIF = function(url, alt) {
    var html='<div>'
        html+= '<img width="100%" src="' + url + '"  dataLabel="' + alt + '"   />';
//        html+='<hr align=center width=50% color=#987cb9 size=1 style="margin:50px auto"/>'
        html+='</div>'
        html+='<div><br/></div>'
      RE.insertHTML(html);

};
//插入视频poster="'+url+'?x-oss-process=video/snapshot,t_1000,w_0,h_0,f_jpg,m_fast"//x5-video-player-fullscreen="true" x5-video-player-type="h5"
RE.insertVideo=function(url,alt){
   var  html='<div>'
        html+='<video width="100%" poster="'+alt+'?x-oss-process=image/auto-orient,1" style="background:black" controls>'
        html+= '<source src="'+url+'" alt="'+alt+'" type="video/mp4">'
        html+='</video>'
        html+='</div>'
        html+='<div><br/></div>'
        RE.insertHTML(html);
};

//插入标签
RE.insertLabels=function(id,name){
    var html='&nbsp;&nbsp<div style="color:rgb(11,124,255);display:inline-block">'+"#"+name
        html+='</div>&nbsp;&nbsp'
      //  html+='&nbsp;&nbsp;'
    RE.insertHTML(html);
};

//插入商品图片onclick=myObj.articleShopImageFunction('11')
RE.insertGoodImg=function(url,id){
  var html='<div>'
     html+= '<img width="100%" data-tbkGoodsId="'+id+'" onclick = window.webkit.messageHandlers.articleShopImageFunction.postMessage('+id+')    src="' + url + '"/>';
    // html+='<hr align=center width=50% color=#987cb9 size=1 style="margin:50px auto"/>'
     html+='</div>'
     html+='<div><br/></div>'
     RE.insertHTML(html);
};
//插入商品模块
RE.insertGoodDiv=function(id,name,img,price,original_price,coupon,activity){
   var html='<section><br/></section>'
   //是否活动
   if(activity==0){
            html += '<section contenteditable="false" onclick="window.webkit.messageHandlers.articleShopImageFunction.postMessage('+id+')" class="tbkgoods newTbkGoods"  data-id="'+id+'" style="-webkit-user-select:none;margin: auto;width:96%;box-sizing:border-box;position:relative;font-size: 14px;box-shadow: 0px 4px 20px #ccc;border-radius:8px 8px 0 0">';
            html+='<section style="width:100%;border-radius:8px 8px 0 0;position:relative;">';
            html+='<img style="vertical-align: bottom;width:100%;border-radius:8px 8px 0 0" src="'+img+'" alt="">';
            html+='<section style="height:60px;position:absolute;width:90%;left:0px;bottom:30px;border-radius:0px 30px 30px 0px;background-color:rgba(0,0,0,0.7);color:#fff;line-height:20px;padding:10px 15px 10px 10px;">';
            html+='<section class="goods_name" style="height:40px;overflow:hidden;text-overflow: ellipsis;display:-webkit-box;-webkit-line-clamp: 2;-webkit-box-orient: vertical;">'+name+'</section></section></section>';
            html+='<section style="background-color:#fff;padding:15px 16px;position:relative"><section style="display:inline-block;color:rgb(255,38,38);">';
            html+='<section style="display:inline-block;font-size:14px;font-weight:400">¥</section>';
            html+='<section class="goods_price" style="display:inline-block;font-size:30px;font-weight:700">'+price+'</section>';
            if(original_price==0){
                html+='<section class="goods_original_price" style="display:none;font-size:14px;margin-left:8px;color:#bbb;text-decoration:line-through">¥0.00</section></section>';
            }else{
            html+='<section class="goods_original_price" style="display:inline-block;font-size:14px;margin-left:8px;color:#bbb;text-decoration:line-through">¥'+original_price+'</section></section>';
            }
            html+='<section style="position:absolute;background-image: linear-gradient(to bottom , rgb(255,44,143), rgb(251,37,43));width:80px;height:30px;border-radius:15px;text-align:center;line-height:30px;color:#fff;right:15px;top:15px;">立即购买</section>';
            if(coupon==0){
                html+='<section class="goods_coupon"  style="display:none;color:rgb(255,38,38);width:fit-content;padding:0px 10px;height:30px;border-radius:15px;text-align:center;line-height:28px;border:1px solid rgb(255,38,38);margin-top:10px">30元优惠券</section></section>';
            }else{
                html+='<section class="goods_coupon"  style="display:static;color:rgb(255,38,38);width:fit-content;padding:0px 10px;height:30px;border-radius:15px;text-align:center;line-height:28px;border:1px solid rgb(255,38,38);margin-top:10px">'+coupon+'元优惠券</section></section>';
            }

            html+='<section style="width:100%;position:absolute;height:1px;margin-top:-5px"><img style="width:100%;vertical-align:top" src="https://starbox-prod.oss-cn-hangzhou.aliyuncs.com/border/border.png" alt=""></section>';
            html+='<input class="goodcover" type="text" onfocus="this.blur();" style="border:none;background-color:transparent;color: transparent;position:absolute;top:-10px;bottom:-30px;left:-10px;right:-10px;z-index:9999"></input></section><p class="tbkGoodsP"></p>';


    }else{


       html+=' <section contenteditable="false" onclick="window.webkit.messageHandlers.articleShopImageFunction.postMessage('+id+')" class="tbkgoods newTbkGoods" data-id="'+id+'" style="-webkit-user-select:none;margin: auto;width:96%;box-sizing:border-box;position:relative;font-size: 14px;box-shadow: 0px 4px 20px #ccc;border-radius:8px 8px 0 0"><section style="width:100%;border-radius:8px 8px 0 0;position:relative;">';
       html+='<img style="vertical-align: bottom;width:100%;border-radius:8px 8px 0 0" src="'+img+'" alt="">';
       html+=' <section style="box-sizing:border-box;height:60px;position:absolute;width:90%;left:0px;bottom:30px;border-radius:0px 30px 30px 0px;background-color:rgba(0,0,0,0.7);color:#fff;line-height:20px;padding:10px 15px 10px 10px;padding-left:35px;"><img class="tbkGoodsImg"  src="https://starbox-prod.oss-cn-hangzhou.aliyuncs.com/border/rob.png" alt="" style="position:absolute;width:22px;left:10px;top:9px">';
       html+=' <section class="goods_name" style="height:40px;overflow:hidden;text-overflow: ellipsis;display:-webkit-box;-webkit-line-clamp: 2;-webkit-box-orient: vertical;">'+name+'</section></section></section>';
       html+=' <section style="background-color:#fff;padding:8px 16px;position:relative"><section style="display:inline-block;color:rgb(255,38,38);"><section style="display:inline-block;font-size:14px;font-weight:400">¥</section>';

       html+=' <section class="goods_price" style="display:inline-block;font-size:30px;font-weight:700">'+price+'</section>';

       if(original_price==0){
           html+='  <section class="goods_original_price" style="display:none;font-size:14px;margin-left:8px;color:#bbb;text-decoration:line-through">¥0.00</section></section>';

       }else{
            html+='  <section class="goods_original_price" style="display:inline-block;font-size:14px;margin-left:4px;color:#bbb;text-decoration:line-through">¥'+original_price+'</section></section>';
      }

       html+=' <section style="position:absolute;background-image: linear-gradient(to bottom , rgb(255,44,143), rgb(251,37,43));width:90px;height:30px;border-radius:15px;text-align:center;line-height:30px;color:#fff;right:15px;top:30px;vertical-align:middle;"><img class="tbkGoodsImg" src="https://starbox-prod.oss-cn-hangzhou.aliyuncs.com/border/lightning.png" alt="" style="width:10px;margin-right:5px;vertical-align:middle;">马上抢</section>';
       html+=' <section class="goods_coupon" style="display:static;width:fit-content;"><img class="tbkGoodsImg"   src="https://starbox-prod.oss-cn-hangzhou.aliyuncs.com/border/flashsale.png" alt="" style="width:120px;"></section></section>';
        html+=' <section style="width:100%;position:absolute;height:10px; margin-top:-5px"><img class="tbkGoodsImg" style="width:100%;vertical-align:top" src="https://starbox-prod.oss-cn-hangzhou.aliyuncs.com/border/border.png" alt=""></section>';
       html+=' <input class="goodcover" type="text" onfocus="this.blur();" style="border:none;background-color:transparent;color:transparent;position:absolute;top:-10px;bottom:-30px;left:-10px;right:-10px;z-index:9999"></section><p class="tbkGoodsP"></p>';
    }

    html+='<section><br><br/></section>'








    RE.insertHTML(html);

}



RE.insertHTML = function(html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);
};
//滚动到底部
RE.scrollToBottom=function(){
    var e= RE.editor;
    e.scrollTop = e.scrollHeight;
    console.log(e.scrollHeight);
};

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length == 0) {
        document.execCommand("insertHTML",false,"<a href='"+url+"'>"+title+"</a>");
    } else if (sel.rangeCount) {
       var el = document.createElement("a");
       el.setAttribute("href", url);
       el.setAttribute("title", title);

       var range = sel.getRangeAt(0).cloneRange();
       range.surroundContents(el);
       sel.removeAllRanges();
       sel.addRange(range);
   }
    RE.callback();
};

RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
};

RE.prepareInsert = function() {
    RE.backuprange();
};

RE.backuprange = function(){
    var selection = window.getSelection();

    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};
    }
    //console.log(selection);
};

RE.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
};

RE.enabledEditingItems = function(e) {
    var items = [];
    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }
    window.location.href = "re-state://" + encodeURI(items.join(','));
};
RE.focus = function() {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    RE.editor.focus();
};

RE.blurFocus = function() {
    RE.editor.blur();
};

RE.removeFormat = function() {
    document.execCommand('removeFormat', false, null);
};

// Event Listeners
RE.editor.addEventListener("input", RE.callback);

RE.editor.addEventListener("keyup", function(e) {
    var KEY_LEFT = 37, KEY_RIGHT = 39;
    if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
        RE.enabledEditingItems(e);
    }
      //  console.log("================"+e.which);
});

RE.editor.addEventListener("keydown",function(e){
    var KEY_LEFT = 8, KEY_RIGHT = 46;
     if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
        var selection = window.getSelection();
        var range = selection.getRangeAt(0);
        if (window.$(range.startContainer).prev().attr("class") == "tbkgoods newTbkGoods") {
           window.$(range.startContainer).prev().remove();

        }
        if (window.$(range.startContainer).attr("class") == "goodcover"||window.$(range.startContainer).parent.attr("class") == "goodcover") {
           window.$(range.startContainer).parent().remove();
        }
     }else {
        var selection = window.getSelection();
        var range = selection.getRangeAt(0);
        if (window.$(range.startContainer).attr("class") == "goodcover") {
           e.preventDefault()
        }
     }
})

RE.editor.addEventListener("click", RE.enabledEditingItems);




